
//Source for a igs_reg test program capable to change all igs vga registers
// in real time...
//Woody, April 1998

#define REGE46C (0xE46C - 0xE430)/4

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/errno.h>
#include <fcntl.h>
#include "igsvga.h"



main(int argc, char *argv[])
{
unsigned int regno, val, i;
struct reg_ops rops;
int igsvga_fd=-1;
unsigned supported;
int source;



unsigned long e46c;

    igsvga_fd=open("/dev/igsvga",O_RDWR);
    if(igsvga_fd<0){
      perror("igs_reg: igsvga not found!");
      exit(-1);
    }

    for(i = 30; i < 40; i++)
    	printf("\033[1;%dmX\tX\tX\tX\tX\tX\n", i);

    for(i = 30; i < 40; i++)
    	printf("\033[0;%dmX\tX\tX\tX\tX\tX\n", i);
	

    if(argc == 2)
    {
    	sscanf(argv[1], "%i", &e46c);
	rops.reg_t = TV_CMD;
	rops.reg = REGE46C;
	rops.val = e46c;
	ioctl(igsvga_fd,IGSVGA_WRITE_SPECIFIC,(unsigned long)&rops);
    }
    else
    {
  	for(e46c = 0; e46c < 0xFFFF; e46c++)
	{
		rops.reg_t = TV_CMD;
		rops.reg = REGE46C;
		rops.val = e46c;
		ioctl(igsvga_fd,IGSVGA_WRITE_SPECIFIC,(unsigned long)&rops);
		usleep(1000);
	}
	if((e46c % 0x100) == 0)
	{
		printf("\033[1;34m%x\t", e46c);
		fflush(stdout);
	}
    }
    close(igsvga_fd);
}
